Forum.WEB/Controllers/RolesController.cs
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Identity.EntityFrameworkCore;
using Forum.WEB.Models;
using Forum.WEB.ViewModel;
using Forum.DAL.Entities;
using Microsoft.AspNetCore.Authorization;

namespace Forum.WEB.Controllers
{
    /// <summary>
    ///     Controller that performs display of all roles and users with their roles
    /// </summary>
    [Authorize(Roles = "Root")]
    public class RolesController : Controller
    {
        RoleManager<IdentityRole> _roleManager;
        UserManager<User> _userManager;

        /// <summary>
        ///     Method that creates the roles controller (add role, define a person's role)
        /// </summary>
        /// <param name="roleManager">
        ///     Role manager to manage them
        /// </param>
        /// <param name="userManager">
        ///     User manager to manage them
        /// </param>
        public RolesController(RoleManager<IdentityRole> roleManager, UserManager<User> userManager)
        {
            _roleManager = roleManager;
            _userManager = userManager;
        }

        /// <summary>
        ///     Method that renders page with all roles
        /// </summary>
        /// <returns>
        ///     Page with all roles
        /// </returns>
        public IActionResult Index() => View(_roleManager.Roles.ToList());

        /// <summary>
        ///     Method that renders page with add new roles fields
        /// </summary>
        /// <returns>
        ///     Page with roles fields
        /// </returns>
        public IActionResult Create() => View();


        /// <summary>
        ///     Method that process add new role for provided role name data
        /// </summary>
        /// <param name="name">
        ///     Registration data from form
        /// </param>
        /// <returns>
        ///     Page with list of all roles
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> Create(string name)
        {
            if (!string.IsNullOrEmpty(name))
            {
                IdentityResult result = await _roleManager.CreateAsync(new IdentityRole(name));
                if (result.Succeeded)
                {
                    return RedirectToAction("Index");
                }
                else
                {
                    foreach (var error in result.Errors)
                    {
                        ModelState.AddModelError(string.Empty, error.Description);
                    }
                }
            }
            return View(name);
        }

        /// <summary>
        ///     Method that deleting a role
        /// </summary>
        /// <param name="id">
        ///     Id role with we want deleted
        /// </param>
        /// <returns>
        ///     Page with list of all roles without one
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> Delete(string id)
        {
            IdentityRole role = await _roleManager.FindByIdAsync(id);
            if (role != null)
            {
                IdentityResult result = await _roleManager.DeleteAsync(role);
            }
            return RedirectToAction("Index");
        }


        /// <summary>
        ///     Method that renders page with all users with their roles
        /// </summary>
        /// <returns>
        ///     Page with all users with their roles
        /// </returns>
        public IActionResult UserList() => View(_userManager.Users.ToList());

        /// <summary>
        ///     Method that process editing user role for provided user Id data
        /// </summary>
        /// <param name="userId">
        ///     Id users with we want change role
        /// </param>
        /// <returns>
        ///     Page with editing user role
        /// </returns>
        public async Task<IActionResult> Edit(string userId)
        {
            User user = await _userManager.FindByIdAsync(userId);
            if (user != null)
            {
                var userRoles = await _userManager.GetRolesAsync(user);
                var allRoles = _roleManager.Roles.ToList();
                ChangeRoleViewModel model = new ChangeRoleViewModel
                {
                    UserId = user.Id,
                    UserEmail = user.Email,
                    UserRoles = userRoles,
                    AllRoles = allRoles
                };
                return View(model);
            }

            return NotFound();
        }

        /// <summary>
        ///     Method that editing user role for provided user Id data
        /// </summary>
        /// <param name="userId">
        ///     Id users with we want change role
        /// </param>
        /// <param name="roles">
        ///     list of user roles 
        /// </param>
        /// <returns>
        ///     Page with all users with their roles
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> Edit(string userId, List<string> roles)
        {
            User user = await _userManager.FindByIdAsync(userId);
            if (user != null)
            {
                
                var userRoles = await _userManager.GetRolesAsync(user);
                
                var allRoles = _roleManager.Roles.ToList();
                
                var addedRoles = roles.Except(userRoles);
                
                var removedRoles = userRoles.Except(roles);

                await _userManager.AddToRolesAsync(user, addedRoles);

                await _userManager.RemoveFromRolesAsync(user, removedRoles);

                return RedirectToAction("UserList");
            }

            return NotFound();
        }
    }
}

Forum.WEB/Controllers/UsersController.cs
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Identity;
using Forum.DAL.Entities;
using Forum.WEB.ViewModel;
using Forum.DAL.Interfaces;
using AutoMapper;
using Forum.BLL.Services;
using Microsoft.AspNetCore.Authorization;
using Forum.BLL.Interfaces;

namespace Forum.WEB.Controllers
{
    /// <summary>
    ///     Controer that performs display of all users
    /// </summary>
    [Authorize(Roles = "Admin,Root")]
    public class UsersController : Controller
    {
        public IMapper _mapper;
        public IUserService _userService;
        UserManager<User> _userManager;

        /// <summary>
        ///     Method that creates the users controller (add/edit/delete users)
        /// </summary>
        /// <param name="mapper">
        ///     Mapper to create projections of one model in other model
        /// </param>
        /// <param name="userManager">
        ///     User manager to manage them
        /// </param>
        /// <param name="userService">
        ///     Interface for working with user in the database indirectly
        /// </param>
        public UsersController(UserManager<User> userManager, 
            IMapper mapper,
            IUserService userService)
        {
            _mapper = mapper;
            _userManager = userManager;
            _userService = userService;
        }

        /// <summary>
        ///     Method that renders page with all users
        /// </summary>
        /// <returns>
        ///     Page with all users
        /// </returns>
        public IActionResult Index()
        {
            return View(_userManager.Users.ToList());
        }

        /// <summary>
        ///     Method that renders page which has fields for creating a user
        /// </summary>
        /// <returns>
        ///     Page which has fields for creating a user
        /// </returns>
        public IActionResult Create() => View();

        /// <summary>
        ///     Method that process creating user for provided user data
        /// </summary>
        /// <param name="CreateUserModel">
        ///     User data from form
        /// </param>
        /// <returns>
        ///     Main page 
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> Create(CreateUserViewModel CreateUserModel)
        {
            if (ModelState.IsValid)
            {
                User user = new User
                {
                    Email = CreateUserModel.Email,
                    UserName = CreateUserModel.UserName,
                    FirstName = CreateUserModel.FirstName,
                    LastName = CreateUserModel.LastName,
                    Rating = 0
                };
                var result = await _userManager.CreateAsync(user, CreateUserModel.Password);
                if (result.Succeeded)
                {
                    return RedirectToAction("Index", "Home");
                }
                else
                {
                    foreach (var error in result.Errors)
                    {
                        ModelState.AddModelError(string.Empty, error.Description);
                    }
                }
            }
            return View(CreateUserModel);
        }


        /// <summary>
        ///     Method that allows you to edit the user
        /// </summary>
        /// <param name="id">
        ///     Id user with we want eding user
        /// </param>
        /// <returns>
        ///      Page with user eding fields
        /// </returns>
        public async Task<IActionResult> Edit(string id)
        {
            User user = await _userManager.FindByIdAsync(id);
            if (user == null)
            {
                return NotFound();
            }
            EditUserViewModel model = new EditUserViewModel
            {
                Id = user.Id,
                Email = user.Email,
                UserName = user.Email,
                FirstName = user.FirstName,
                LastName = user.LastName
            };
            return View(model);
        }

        /// <summary>
        ///     Method that process edit the user for provided user data
        /// </summary>
        /// <param name="EditUserModel">
        ///     User data from form
        /// </param>
        /// <returns>
        ///     Redirect to page with list all users
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> Edit(EditUserViewModel EditUserModel)
        {
            if (ModelState.IsValid)
            {
                User user = await _userManager.FindByIdAsync(EditUserModel.Id);
                if (user != null)
                {
                    user.Email = EditUserModel.Email;
                    user.FirstName = EditUserModel.FirstName;
                    user.LastName = EditUserModel.LastName;
                    user.UserName = EditUserModel.Email;

                    var result = await _userManager.UpdateAsync(user);
                    if (result.Succeeded)
                    {
                        return RedirectToAction("Index");
                    }
                    else
                    {
                        foreach (var error in result.Errors)
                        {
                            ModelState.AddModelError(string.Empty, error.Description);
                        }
                    }
                }
            }
            return View(EditUserModel);
        }

        /// <summary>
        ///     Method that deleting a users
        /// </summary>
        /// <param name="id">
        ///     Id role with we want deleted
        /// </param>
        /// <returns>
        ///     Page with list of all users without one
        /// </returns>
        [HttpPost]
        public async Task<ActionResult> Delete(string id)
        {
            User user = await _userManager.FindByIdAsync(id);
            if (user != null)
            {
                IdentityResult result = await _userManager.DeleteAsync(user);
            }
            return RedirectToAction("Index");
        }
    }
}

Forum.WEB/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ЧГК Форум</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">ЧГК Форум</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        @if(User.IsInRole("Admin") || User.IsInRole("Root"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-controller="Users" asp-action="Index" disabled>Список пользователей</a>
                            </li>
                        }
                        @if(User.IsInRole("Root"))
                        {
                            <li>
                                <a class="nav-link text-dark" asp-controller="Roles" asp-action="Index" disabled>Список Ролей</a>
                            </li>
                        }
                    </ul>
                    @if(User.Identity.IsAuthenticated)
                            {
                                <div>
                                    @User.Identity.Name
                                </div>
                                <form method="post" asp-controller="Account" asp-action="Logout">
                                    <input type="submit" value="Выход" class="btn button"/>
                                </form>
                            }
                            @if(!User.Identity.IsAuthenticated)
                            {
                                
                                <a asp-controller="Account" asp-action="Login" class="btn button" >Вход</a>
                                <a asp-controller="Account" asp-action="Register" class="btn button">Регистрация </a>
                            }
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

@*    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - Forum.WEB - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>*@

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>

    <script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.17.0/jquery.validate.min.js"
        asp-fallback-src="~/lib/jquery-validation/dist/jquery.validate.min.js"
        asp-fallback-test="window.jQuery && window.jQuery.validator">
    </script>
    <script src="https://ajax.aspnetcdn.com/ajax/jquery.validation.unobtrusive/3.2.10/jquery.validate.unobtrusive.min.js"
        asp-fallback-src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.min.js"
        asp-fallback-test="window.jQuery && window.jQuery.validator && window.jQuery.validator.unobtrusive">
    </script>

    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>